<?php
namespace Mirasvit\Misspell\Model\Indexer;

/**
 * Interceptor class for @see \Mirasvit\Misspell\Model\Indexer
 */
class Interceptor extends \Mirasvit\Misspell\Model\Indexer implements \Magento\Framework\Interception\InterceptorInterface
{
    use \Magento\Framework\Interception\Interceptor;

    public function __construct(\Mirasvit\Misspell\Model\ConfigProvider $configProvider, \Magento\Store\Model\StoreManagerInterface $storeManager)
    {
        $this->___init();
        parent::__construct($configProvider, $storeManager);
    }

    /**
     * {@inheritdoc}
     */
    public function reindex() : void
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'reindex');
        $pluginInfo ? $this->___callPlugins('reindex', func_get_args(), $pluginInfo) : parent::reindex();
    }

    /**
     * {@inheritdoc}
     */
    public function executeFull() : void
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'executeFull');
        $pluginInfo ? $this->___callPlugins('executeFull', func_get_args(), $pluginInfo) : parent::executeFull();
    }

    /**
     * {@inheritdoc}
     */
    public function executeList(array $ids) : void
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'executeList');
        $pluginInfo ? $this->___callPlugins('executeList', func_get_args(), $pluginInfo) : parent::executeList($ids);
    }

    /**
     * {@inheritdoc}
     */
    public function executeRow($id) : void
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'executeRow');
        $pluginInfo ? $this->___callPlugins('executeRow', func_get_args(), $pluginInfo) : parent::executeRow($id);
    }

    /**
     * {@inheritdoc}
     */
    public function execute($ids) : void
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'execute');
        $pluginInfo ? $this->___callPlugins('execute', func_get_args(), $pluginInfo) : parent::execute($ids);
    }
}
